#ifndef _KRNLDEF_H
#define _KRNLDEF_H


typedef enum _KAPC_ENVIRONMENT {
    OriginalApcEnvironment,
    AttachedApcEnvironment,
    CurrentApcEnvironment
} KAPC_ENVIRONMENT;


/* Internal driver functions' definitions
 */

NTSTATUS
ZwTerminateProcess(
    HANDLE ProcessHandle,
    NTSTATUS ExitStatus);

NTSTATUS
ZwOpenProcess(
    PHANDLE ProcessHandle,
    ACCESS_MASK DesiredAccess,
    POBJECT_ATTRIBUTES ObjectAttributes,
    PCLIENT_ID ClientId);

NTSTATUS
ZwCreateEvent(
    PHANDLE EventHandle,
    ACCESS_MASK DesiredAccess,
    POBJECT_ATTRIBUTES ObjectAttributes,
    EVENT_TYPE EventType,
    BOOLEAN InitialState);

NTSTATUS
ZwWaitForSingleObject(
    HANDLE Handle,
    BOOLEAN Alertable,
    PLARGE_INTEGER Timeout);

NTSTATUS
ZwDuplicateObject(
	  HANDLE SourceProcessHandle,
	  HANDLE SourceHandle,
	  HANDLE TargetProcessHandle,
	  PHANDLE TargetHandle OPTIONAL,
	  ACCESS_MASK DesiredAccess,
	  ULONG Attributes,
	  ULONG Options
	);

NTSTATUS
KeInitializeApc (
    PRKAPC Apc,
    PKTHREAD Thread,
    KAPC_ENVIRONMENT Environment,
    PKKERNEL_ROUTINE KernelRoutine,
    PKRUNDOWN_ROUTINE RundownRoutine OPTIONAL,
    PKNORMAL_ROUTINE NormalRoutine OPTIONAL,
    KPROCESSOR_MODE ApcMode,
    PVOID NormalContext
    );

BOOLEAN
KeInsertQueueApc (
    PRKAPC Apc,
    PVOID SystemArgument1,
    PVOID SystemArgument2,
    KPRIORITY Increment
    );

#endif

